/***
*	bplib.h -- header for link library BPLib.lib
*	 1993 Another Option
***/

/*
============================================================================
|    DATE    | WHAT
============================================================================
	 6 Feb 93 | created
   14 Feb 93 | added display poop macros
	 7 Jul 93 | added BozoRequest macros
	18 Sep 93 | added snapshot gadget stuff
	16 Nov 93 | exposed as v1.0
	11 Feb 94 | added HILO_DPEN
*/


#ifndef BP_LIB_H
#define BP_LIB_H

#ifndef XOffset
 #ifndef GRAPHICS_RASTPORT_H
  #include <graphics/rastport.h>
 #endif

 /* for display of a prop gadget value */
 #define XOffset 41 /* relative to g->LeftEdge + g->Width (allowing 36 for clickers) */
 #define YOffset 6  /* relative to g->TopEdge */
 #define HILO_APEN 1
 #define HILO_BPEN 0
 /* HILO_DPEN renders gadget value for a disabled gadget */
 #define HILO_DPEN 3
 #define HILO_DRAWMODE JAM2

 /* stuff for rendering menus */
 #define MENU_APEN 3
 #define MENU_BPEN 0
 #define MENU_DRAWMODE JAM1

#endif

#ifndef INTUITION_INTUITION_H
 #include <intuition/intuition.h>
#endif

/* macros to aid in zooming a window */
#define WindowIsTall(w) ( (w)->Height >= (w)->MaxHeight )
#define WindowIsWide(w) ( (w)->Width >= (w)->MaxWidth )
#define WindowIsBig(w) ( WindowIsTall(w) || WindowIsWide(w) )
#define WindowIsMax(w) ( WindowIsTall(w) && WindowIsWide(w) )

#ifndef BR_YES
 /* GadgetIDs and return values for BozoRequest stuff */
 #define BR_YES 1
 #define BR_NO 2
 #define BR_CLOSEWINDOW 3
 #define BR_ERRORRETURN -1
#endif

/* id for the configuration gadget in the title bar */
#ifndef CONFIG_GADGET_ID
 #define CONFIG_GADGET_ID 667
#endif

/* id for the snapshot gadget in the title bar */
#ifndef SNAPSHOT_GADGET_ID
 #define SNAPSHOT_GADGET_ID 668
#endif

/* id for the music/smpte time gadget in the title bar */
#ifndef TIMETOGGLE_GADGET_ID
 #define TIMETOGGLE_GADGET_ID 669
#endif

/* sysex manufacturer id used for tools (in honor of Dave Smith) */
#ifndef TOOL_SYSEX_ID
 #define TOOL_SYSEX_ID 0x01
#endif



/*** these are for making a gst for tool development ***/
#ifdef BPLIB_MAKEGST
 #include <exec/types.h>
 #include <exec/exec.h>
 #include <proto/exec.h>
 #include <graphics/gfx.h>
 #include <proto/graphics.h>
 #include <intuition/intuition.h>
 #include <proto/intuition.h>
 #include <clib/alib_protos.h>
 #include <clib/alib_stdio_protos.h>
 #include "bars.h"
 #include "edit.h"
#endif


#ifndef BPLIB_COMPILE
 /* oops */
 #define Snapshot(a,b,c,d) BuildSnapshot(a,b,c,d)
 #ifndef BPLIB_PROTO_H
  #include "proto/bplib_protos.h"
 #endif
#endif

#endif
