/***
* 	ConfigLib.h -- declarations for ConfigLib.lib
* 	 1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE    | WHAT
============================================================================
   31 Jan 93 | created from stuff in pcmaskconfig.c
    1 Feb 93 | edited for static ControllerInfos (cf. configlib.c); added
             | additional CITYPE_s.
	31 Dec 93 | stripped down to what is actually necessary
	 8 Jan 94 | got rid of high-bit flags to be MIDI friendlier
*/

#ifndef CONFIG_LIB_H
#define CONFIG_LIB_H 1

#ifndef EXEC_TYPES_H
 #include <exec/types.h>
#endif

#ifndef BARS_H
 #include "bars.h"
#endif

/* id for the configuration gadget in the title bar */
#define CONFIG_GADGET_ID 667

/*
   this structure keeps track of an individual controller.  embed an array
   of these in a tool
*/
struct ControllerInfo {
	BYTE controller;   /* respond to this midi controller number */
	UBYTE range;       /* range of data allowed */
	UBYTE type;        /* CITYPE_ */
	UBYTE flags;       /* there will undoubtedly be some... */
};

/*** bits for ControllerInfo.type ***/
/* switches are 64..120 */
#define CITYPE_SWITCH 1
/* 7-bit continuous are 0..63 */
#define CITYPE_CONTIN 2
/* 14-bit continuous MSBs are 0..31 */
#define CITYPE_CONT14 4
/* don't care to distinguish between switch and continuous 0..120; off=-1 */
#define CITYPE_NODIFF 8
/* set by UpdateControllers() if switch is 63, or continuous is -1 */
#define CITYPE_OFF 64


/*** ranges for CITYPE_s ***/
#define CI_SWITCHRANGE 0x39 //57
#define CI_CONTINRANGE 0x40 //64
#define CI_CONT14RANGE 0x20 //32
#define CI_NODIFFRANGE 0x79 //121


/*** bits for ControllerInfo.flags ***/
/* this is the last element in the array */
#define CIFLAG_LAST   64
/* this array element has been initialized */
#define CIFLAG_INIT    2
/* throw away these controller inputs after use */
#define CIFLAG_DISCARD 1

#ifndef CONFIGLIB_COMPILE
 #include "ConfigFrame.h"
 #include "ConfigDiscardImagery.h"
 #include "proto/ConfigLib_protos.h"
#endif

#endif