/***
*		bpl_InPad.c -- determine whether a tool is in the ToolPad
*		 1996 Another Option   All rights reserved.
***/

/*
=============================================================================
|   DATE   | WHAT
=============================================================================
 13 Nov 96 | created (from code in bpl_edwintit.c)
*/

#include <exec/types.h>
#include "bars.h"
#include "proto/bpl_inpad_protos.h"

extern struct Functions *functions;

/*==========================================================================
* InToolPad
*
*  INPUT: pointer to Tool
* RETURN: instance number of tool in toolpad, or 0 if not in toolpad
*
* EFFECT: looks at tools in toolpad, comparing toolid and pointer to try
*         and find a match
*=========================================================================*/


UBYTE InToolPad(tool)

struct Tool *tool;

{
	UBYTE i;
	UBYTE count = 0;
	
	for (i = 0 ; (i < 16) && functions->edittools[i] ; i++) {
		if (functions->edittools[i]->toolid == tool->toolid) {
			count++;
			if (functions->edittools[i] == tool) { /* this is us */
				return(count);
			}
		}
	}
	/* else didn't find a match */
	return(0);
}
