/***
* 	bpl_newclosewind.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
  12 Jan 94 | created to put open and close in separate source files 
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/intuition.h>
#include <string.h>
#include "bars.h"
#include "barsmacros.h"
#include "proto/bpl_newclosewind_protos.h"

extern struct IntuitionBase *IntuitionBase;
extern struct Functions * far functions;

/*==========================================================================
* NewCloseEmbossedWindow
*
*  INPUT: pointer to tool and NewWindow created with DupeNewWindow
* RETURN: none
*
* EFFECT: saves window stuff in tool, closes tool->window, deletes new window
*=========================================================================*/

void NewCloseEmbossedWindow(tool, nw)

struct Tool *tool;
struct NewWindow *nw;

{
	struct Gadget *g = functions->GetGadget(tool->window,EMBOSSED_DRAG);

	tool->left = tool->window->LeftEdge;
	tool->top = tool->window->TopEdge;
	tool->width = tool->window->Width;
	tool->height = tool->window->Height;
	tool->touched |= TOUCH_EDIT;
	if (tool->window->MenuStrip) ClearMenuStrip(tool->window);
	if (g) functions->myfree(g->GadgetText->IText,strlen(g->GadgetText->IText)+1);
	functions->EmbossWindowOff(tool->window);
	functions->FlashyCloseWindow(tool->window);
	tool->window = NULL;
	if (nw) functions->DeleteNewWindow(nw);
}
