/***
* 	bpl_newopenwind.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
  18 Oct 93 | created from bpl_window.c to support dynamic window titles
  12 Jan 94 | put open and close in separate source files
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/intuition.h>
#include <string.h>
#include "bars.h"
#include "barsmacros.h"
#include "proto/bpl_newopenwind_protos.h"

extern struct IntuitionBase *IntuitionBase;
extern struct Functions * far functions;

extern char *MakeEditWindowTitle(struct Tool *, const char *, long );

/*==========================================================================
* NewOpenEmbossedWindow
*
*  INPUT: pointer to NewWindow and tool, window flags, pointer to window title
* RETURN: pointer to NewWindow and pointer to Window in tool->window if
*         opened, else NULL
*
* EFFECT: twiddles with NewWindow and opens embossed window.  if flags==0,
*         defaults are used 
*=========================================================================*/

struct NewWindow *NewOpenEmbossedWindow(new, tool, flags, title)

struct NewWindow *new;
struct Tool *tool;
ULONG flags;
const char *title;

{
	struct NewWindow *nw;
	char *wtitle;

	nw = (struct NewWindow *)functions->DupeNewWindow(new);
	if (nw) {
		if (tool->touched & TOUCH_EDIT) {
			nw->LeftEdge = tool->left;
			nw->TopEdge = tool->top;
			nw->Width = tool->width;
			nw->Height = tool->height;
		}
/** new stuff: put window in the vicinity of the tool icon **/
		else {
			nw->TopEdge = tool->y+23; /* at the bottom of the icon */
			if (nw->TopEdge + nw->Height > functions->screen->Height) {
				nw->TopEdge = functions->screen->Height - nw->Height;
			}
			nw->LeftEdge = tool->x-(nw->Width >> 1)+12; /* centered with icon */
			if (nw->LeftEdge + nw->Width > functions->screen->Width) {
				nw->LeftEdge = functions->screen->Width - nw->Width;
			}
			else if (nw->LeftEdge < 0) nw->LeftEdge=0;
		}
		nw->Screen = functions->screen;
		nw->Title = 0;
		nw->Flags |= BORDERLESS;
		nw->Flags &= ~0xF;
		nw->DetailPen = nw->BlockPen = 0;
		tool->window = (struct Window *)functions->FlashyOpenWindow(nw);
		if (tool->window) {
			/* subtracting 55 allows for close & front gadget; drag text offset */
			wtitle = MakeEditWindowTitle(tool,title,(nw->Width-55)>>3); /* 8 pixel font alert */
			functions->EmbossWindowOn(tool->window, flags ?
			                          flags : WINDOWCLOSE|WINDOWDEPTH|WINDOWDRAG,
											  wtitle,(short)-1,(short)-1,0,0);
		}
		else {
			functions->DeleteNewWindow(nw);
			nw=NULL;
		}
	}
	return(nw);
}

