/***
* 	bplib_RectFill .c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
  8 Jul 93  | created (from lorenz.c)
  6 Jan 94  | added library base (buttwipe)
*/

#include <exec/types.h>
#include <graphics/gfx.h>
#include <graphics/gfxmacros.h>
#include <proto/graphics.h>
#include "bars.h"
#include "proto/bpl_rectfill_protos.h"

//extern struct Functions *functions;
extern struct GfxBase *GfxBase;


/* default pens */
#define DER_HIPEN 1
#define DER_LOPEN 3
#define DER_FILLPEN 2

/*==========================================================================
* DrawEmbossedRectFill
*
*  INPUT: pointer to RastPort, coordinates for upper left corner, coordinates
*         for lower right corner, pen for fill color, up/down flag
*
* RETURN: none
*
* EFFECT: draws a filled rectangle with an embossed border.  if depressed > 0,
*         top and left borders are color 3, and right and bottom are color 1
*         (the box is inset); if depressed==0, top and left are color 1, and
*         right and bottom are color 3 (the box is raised).  (Note that vertical
*         lines are two pixels wide; horizontal lines are one pixel.)
*         If fillpen < 0, the default fill pen is used.
*=========================================================================*/

void DrawEmbossedRectFill(rp, x, y, x2, y2, fillpen, depressed)

struct RastPort *rp;
SHORT x, y, x2, y2, fillpen;
USHORT depressed;

{
	SHORT hipen;
	SHORT lopen;
	
	hipen = depressed ? DER_LOPEN : DER_HIPEN;
	lopen = depressed ? DER_HIPEN : DER_LOPEN;
	if (fillpen < 0) fillpen = DER_FILLPEN;
	
	SetAPen(rp,fillpen);
	SetOPen(rp,hipen);
	SetDrMd(rp,JAM1);
	RectFill(rp,x,y,x2,y2);
	SetAPen(rp,hipen);
	Move(rp,x+1,y);
	Draw(rp,x+1,y2-1);
	SetAPen(rp,lopen);
	Move(rp,x+1,y2);
	Draw(rp,x2-1,y2);
	Draw(rp,x2-1,y+1);
	Move(rp,x2,y);
	Draw(rp,x2,y2);
}
