/***
* 		BPLib_AddTimeToggleGadget.c -- module for BPLib.lib
*  	 1994 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
  16 Jan 94 | created - from bpl_addsnap.c
*/


#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/exec.h>
#include <proto/intuition.h>
#include "bars.h"
#include "proto/bpl_addtimetog_protos.h"

extern struct IntuitionBase *IntuitionBase;
extern struct Functions * far functions;
extern struct Gadget TimeToggleGadget;

/*==========================================================================
* AddTimeToggleGadget
*
*  INPUT: pointer to open b&p embossed window
* RETURN: none
*
* EFFECT: removes title bar gadget, resizes, and refreshes; adds and draws
*         time toggle gadget.  Sets flags in Gadget.UserData to avoid adjusting
*         its location more than once.
*=========================================================================*/

void AddTimeToggleGadget(w)

struct Window *w;

{
   struct Gadget *gadget;
   USHORT position;

	if (functions->GetGadget(w,669)) return; /* one should be sufficient */

	/* make room for the gadget */
	gadget = functions->GetGadget(w,0xFFE);
	functions->EmbossOff(w,0xFFE);
	position = RemoveGadget(w,gadget);
	gadget->Width -= 20;
	AddGList(w,gadget,position,1,NULL);
	RefreshGList(gadget,w,NULL,1);
	functions->EmbossOn(w,0xFFE,1);
	functions->DrawEmbossed(w,0xFFE);

   /* add the snapshot gadget */
	if (!functions->GetGadget(w,667)) { /* the config gadget not there? */
		if (!((long)TimeToggleGadget.UserData & 1)) {
			TimeToggleGadget.LeftEdge += 20; /* move it right */
			TimeToggleGadget.UserData = (APTR)((long)TimeToggleGadget.UserData | 1);
		}
	}
	if (!functions->GetGadget(w,668)) { /* snapshot gadget not there? */
		if (!((long)TimeToggleGadget.UserData & 2)) {
			TimeToggleGadget.LeftEdge += 20; /* move it right */
			TimeToggleGadget.UserData = (APTR)((long)TimeToggleGadget.UserData | 2);
		}
	}
   AddGList(w,&TimeToggleGadget,-1,1,NULL);
	RefreshGList(&TimeToggleGadget,w,NULL,1);
}

