/***
* 	bplib_alohafatp.c -- yet another module for bplib.lib
*   1994 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
  18 Jan 94 | created from lorenz.c
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/intuition.h>
#include "bars.h"
#include "proto/bpl_alohafatp_protos.h"


extern struct Functions * __far functions;


/*==========================================================================
* AlohaFatProp
*
*  INPUT: pointer to window, ids for gadgets to move in and out, id offsets
*         for up and down clickers, Gadget.LeftEdge delta
* RETURN: none
*
* EFFECT: reverses the Gadget.LeftEdge positions of fat prop gadgets that
*         alternately occupy the same location in a window.  Subtracts the
*         delta from the ghi gadget and clickers; adds it to the gbye gadget
*         and clickers.  Then, redraws the props.
*
*   NOTE: ghi must start with its LeftEdge at its position in the window + delta.
*         Both gadgets must have their up and down clickers offset by the same
*         amount (e.g. both up ids are id+100; both downs, id+200).
*=========================================================================*/

void AlohaFatProp(w, ghi, gbye, gup, gdown, delta)

struct Window *w;
WORD ghi;
WORD gbye;
WORD gup;
WORD gdown;
WORD delta;

{
	struct Gadget *g;
	
	/* move into the window */
	g = functions->GetGadget(w,ghi);
	g->LeftEdge -= delta;
	g = functions->GetGadget(w,ghi+gdown);
	g->LeftEdge -= delta;
	g = functions->GetGadget(w,ghi+gup);
	g->LeftEdge -= delta;
	/* move out of the window */
	g = functions->GetGadget(w,gbye);
	g->LeftEdge += delta;
	g = functions->GetGadget(w,gbye+gdown);
	g->LeftEdge += delta;
	g = functions->GetGadget(w,gbye+gup);
	g->LeftEdge += delta;
	/* redraw */
	functions->DrawEmbossedProp(w,gbye);
	functions->DrawEmbossedProp(w,ghi);
}

