/***
* 	bplib_bevelbox.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
  6 Jan 94  | created (from bpl_rectfill.c)
*/

#include <exec/types.h>
#include <graphics/gfx.h>
#include <graphics/gfxmacros.h>
#include <proto/graphics.h>
#include "barsmacros.h"
#include "proto/bpl_bevelbox_protos.h"

extern struct GfxBase *GfxBase;

/* default pens */
 #define BEV_HIPEN BP_LGREY
#define BEV_LOPEN BP_DGREY

/*==========================================================================
* DrawBevelBox
*
*  INPUT: pointer to RastPort, coordinates for upper left corner, coordinates
*         for lower right corner, pens for box edges, up/down flag
*
* RETURN: none
*
* EFFECT: draws an embossed border.  if depressed > 0, the box is raised; if
*         depressed==0, the box is raised.  If shine or shadow is < 0, 
*         default pens are used (white and dark grey).
*
*   NOTE: Vertical lines are two pixels wide; horizontal lines are one pixel.
*=========================================================================*/

void DrawBevelBox(rp, x, y, x2, y2, shine, shadow, depressed)

struct RastPort *rp;
WORD x, y, x2, y2, shine, shadow;
UWORD depressed;

{
	SHORT hipen;
	SHORT lopen;

	if (shine < 0) shine = BEV_HIPEN;
	if (shadow < 0) shadow = BEV_LOPEN;

	hipen = depressed ? shadow : shine;
	lopen = depressed ? shine : shadow;

	SetDrMd(rp,JAM1);
	SetAPen(rp,hipen);
	Move(rp,x2,y);
	Draw(rp,x,y);
	Draw(rp,x,y2);
	Move(rp,x+1,y2);
	Draw(rp,x+1,y);

	SetAPen(rp,lopen);
	Move(rp,x+1,y2);
	Draw(rp,x2-1,y2);
	Draw(rp,x2-1,y+1);
	Move(rp,x2,y);
	Draw(rp,x2,y2);
}
