/***
* 	bplib_event.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   4 Feb 93 | created
*/

/* get min, max, abs macros from string.h */
#define USE_BUILTIN_MATH 1

#include <exec/types.h>
#include <string.h>
#include "bars.h"
#include "proto/bpl_clean_protos.h"

extern struct Functions * far functions;

/*==========================================================================
* CleanseList
*
*  INPUT: pointer to SORTED Event list, minimum allowable difference between
*         consecutive items, offset of data to check
*
* RETURN: none
*
* EFFECT: removes consecutive events with values in the UBYTE at offset
*         whose differences are less than diff.  only checks events with 
*         the same status bytes.
*=========================================================================*/

void CleanseList(list, mindiff, offset)

struct Event *list;
ULONG mindiff;
ULONG offset;

{
	struct Event *prev;  /* previous keeper in the list */
	struct Event *next;  /* next in the list */
	struct Event *junk=NULL; /* list of stuff to free */
	UBYTE prevval;
	UBYTE val;

	if (list) {
		mindiff++;
		prevval = *(((UBYTE *)list)+offset); /* the previous value */
		prev = list;
		list = list->next;
		for ( ; list ; list=next ) {
			next = list->next;
			if (list->status == prev->status) {
				val = *(((UBYTE *)list)+offset);
				if (abs(val-prevval) < mindiff) {
					list->next = junk;
					junk = list;
					prev->next = next;
				}
				else {
					prev = list;
					prevval = val;
				}
			}
			else {
				prev = list;
			}
		}

		if (junk) functions->freelist(junk);
	}
}

