/***
* 	bplib_event.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   4 Feb 93 | created
  11 Jul 93 | modified alloceventlist() to use allocevent() instead of 
            | myalloc() because they get memory from incompatible pools;
				| deleted freeeventlist() because it duplicates functions->freelist()!
*/

#include <exec/types.h>
#include <string.h>
#include <stddef.h>
#include "bars.h"
#include "proto/bpl_event_protos.h"

extern struct Functions * far functions;

/*==========================================================================
* alloceventlist
*
*  INPUT: number of events to allocate
* RETURN: pointer to list of events, or NULL
*
* EFFECT: allocates a bunch of events, sets up pointers.
*=========================================================================*/

struct Event *alloceventlist(count)

ULONG count;

{
	register struct Event *e;
	struct Event *prev = NULL;
	struct Event *list = NULL;

/*
 * this method of allocation does not work because myalloc() and allocevent()
 * apparently get their memory from different pools; mixing them makes memory
 * insane (0100000C, that is)
 *
	list = (struct Event *)(*functions->myalloc)(count*sizeof(struct Event),0);
	if (list) {
		memset((char *)list,count*sizeof(struct Event),0);
		for (i=0 ; i < count-1 ; i++) {
			list[i].next=&list[i+1];
		}
		list[i].next=NULL;
	}
*/

	for ( ; count ; count-- ) {
		if (!(e = functions->allocevent())) break;
		if (!list) list = e;
		memset((void *)e,0,sizeof(struct Event));
		if (prev) prev->next = e;
		prev = e;
	}

	if (count) { /* couldn't allocate enough events */
		if (list) functions->freelist(list);
		list = NULL;
	}
		
	return(list);
}

