/***
* 	bplib_glist.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   4 Feb 93 | created
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include "bars.h"
#include "proto/bpl_glist_protos.h"

extern struct Functions * far functions;

/*============================================================================
* EmbossOnGList
*
*  INPUT: pointer to window, pointer to GList, number of gadgets in list,
*         EmbossOn command
* OUTPUT: none
* RETURN: none
*
* EFFECT: repeatedly calls EmbossOn() to emboss the gadgets in the list
*         using the passed command.  will emboss gadgets in the list until
*         count is reached, or a null pointer is hit in the glist.  note
*         that the gadget ids must be defined in the Gadget structures.
*===========================================================================*/

void EmbossOnGList(w, glist, count, command)

struct Window *w;
struct Gadget *glist;
UWORD count;
WORD command;

{
	for ( ; glist && count ; glist=glist->NextGadget, count-- ) {
		functions->EmbossOn(w,glist->GadgetID,command);
	}
}

/*============================================================================
* EmbossOffGList
*
*  INPUT: pointer to window, pointer to glist to off, number of gadgets
* OUTPUT: none
* RETURN: none
*
* EFFECT: repeatedly calls EmbossOff()
*===========================================================================*/

void EmbossOffGList(w, glist, count)

struct Window *w;
struct Gadget *glist;
UWORD count;

{
	for ( ; glist && count ; glist=glist->NextGadget, count-- ) {
		functions->EmbossOff(w,glist->GadgetID);
	}
}

/*============================================================================
* DrawEmbossedGList
*
*  INPUT: pointer to window, glist, gadget count
* OUTPUT: none
* RETURN: none
*
* EFFECT: calls DrawEmbossed() repeatedly
*===========================================================================*/

void DrawEmbossedGList(w, glist, count)

struct Window *w;
struct Gadget *glist;
UWORD count;

{
	for ( ; glist && count ; glist=glist->NextGadget, count-- ) {
		functions->DrawEmbossed(w,glist->GadgetID);
	}
}

