/***
*		bpl_route.c
*		 1996 Another Option   All rights reserved.
***/

/*
=============================================================================
|   DATE   | WHAT
=============================================================================
 14 Nov 96 | created (from code in chop.c)
*/

#include "bars.h"
#include "proto/bpl_route_protos.h"

extern struct Functions *functions;

/*==========================================================================
* RouteEvent
*
*  INPUT: pointers to event & tool; flags for passing or branching
* RETURN: pointer to event
*
* EFFECT: points event where it should go, or frees it in the pipeline or
*         sets time to -1 for freeing from processlistcode()
*=========================================================================*/

struct Event *RouteEvent(event, tool, pass, branch)

struct Event *event;
struct Tool *tool;
ULONG pass, branch;

{
	if (pass) {
		event->tool = tool->next;
	}
	else if (branch) {
		event->tool = tool->branch;
		event->type |= EVENT_BRANCH;
	}
	else {
		if (!(event->type & EVENT_PADEDIT)) {
			functions->freeevent(event);
			event = NULL;
		}
		else {
			event->time = -1;
		}
	}
	return(event);
}
