/***
* 	bpl_sizetitbar.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   6 Jan 94 | created -- adjusts b&p window title bar for added gadgetry
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/intuition.h>
#include "bars.h"
#include "barsmacros.h"
#include "proto/bpl_sizetitbar_protos.h"

extern struct Functions * far functions;
extern struct IntuitionBase *IntuitionBase;

/* don't let a gadget.Width be less than this */
#define SMALLEST_SIZE 4

/*==========================================================================
* SizeTitleBar
*
*  INPUT: pointer to Window, amount to change
* RETURN: none
*
* EFFECT: adjusts Width of b&p embossed window title bar ostensibly to make
*         room for added gadgetry, such as ConfigGadget and SnapshotGadget.
*         The delta may be positive or negative.  The resulting gadget Width
*         may not be smaller than SMALLEST_SIZE, nor may it be wider than the 
*         window.
*=========================================================================*/

void SizeTitleBar(w,delta)

struct Window *w; /* the window */
WORD delta;       /* change to gadget Width */

{
	register struct Gadget *g;
	long position;
	
	functions->EmbossOff(w,EMBOSSED_DRAG);
	position = RemoveGadget(w,g = functions->GetGadget(w,EMBOSSED_DRAG));
	g->Width += delta;
	/* don't let the gadget get too big or too small */
	if (g->Width < SMALLEST_SIZE) g->Width = SMALLEST_SIZE;
	else if (g->Width > (w->Width-g->LeftEdge)) g->Width = w->Width - g->LeftEdge;
	AddGList(w,g,position,1,NULL);
	RefreshGList(g,w,NULL,1);
	functions->EmbossOn(w,EMBOSSED_DRAG,1);
	functions->DrawEmbossed(w,EMBOSSED_DRAG);
}