/***
* 	bplib_vanish.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   4 Feb 93 | created
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/intuition.h>
#include "proto/bpl_vanish_protos.h"

/*==========================================================================
* VanishGList
*
*  INPUT: pointer to window, glist, gadget count, LeftEdge offset
* RETURN: none
*
* EFFECT: removes glist, adds offset to LeftEdge of each gadget, adds and
*         refreshes glist.  Use to put gadgets outside the window boundaries
*         with a positive offset, or move them back into the window with
*         a negative offset.
*
*   NOTE: only works with boolean and skinny prop gadgets
*=========================================================================*/

void VanishGList(w, glist, count, delta)

struct Window *w;
struct Gadget *glist;
UWORD count;
WORD delta;

{
	struct Gadget *g = glist;
	UWORD pos;
	UWORD num = count;

	if (w) pos = RemoveGList(w,glist,count);
	for ( ; g && num ; g=g->NextGadget, num-- ) {
		g->LeftEdge += delta;
	}
	if (w) AddGList(w,glist,pos,count,NULL);
}

