/***
* 	bplib_window.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   4 Feb 93 | created
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/intuition.h>
#include "bars.h"
#include "proto/bpl_window_protos.h"

extern struct Functions * far functions;

/*==========================================================================
* OpenEmbossedWindow
*
*  INPUT: pointer to NewWindow and tool, window flags, pointer to window title
* RETURN: pointer to NewWindow and pointer to Window in tool->window if
*         opened, else NULL
*
* EFFECT: twiddles with NewWindow and opens embossed window.  if flags==0,
*         defaults are used 
*=========================================================================*/

struct NewWindow *OpenEmbossedWindow(new, tool, flags, title)

struct NewWindow *new;
struct Tool *tool;
ULONG flags;
char *title;

{
	struct NewWindow *nw;
	
	nw = (struct NewWindow *)(*functions->DupeNewWindow)(new);
	if (nw) {
		if (tool->touched & TOUCH_EDIT) {
			nw->LeftEdge = tool->left;
			nw->TopEdge = tool->top;
			nw->Width = tool->width;
			nw->Height = tool->height;
		}
		nw->Screen = functions->screen;
		nw->Title = 0;
		nw->Flags |= BORDERLESS;
		nw->Flags &= ~0xF;
		nw->DetailPen = nw->BlockPen = 0;
		tool->window = (struct Window *)(*functions->FlashyOpenWindow)(nw);
		if (tool->window) {
			(*functions->EmbossWindowOn)(tool->window,
			                             flags ? flags : WINDOWCLOSE|WINDOWDEPTH|WINDOWDRAG,
																	 title,(short)-1,(short)-1,0,0);
		}
		else {
			(*functions->DeleteNewWindow)(nw);
			nw=NULL;
		}
	}
	return(nw);
}

/*==========================================================================
* CloseEmbossedWindow
*
*  INPUT: pointer to tool and NewWindow created with DupeNewWindow
* RETURN: none
*
* EFFECT: saves window stuff in tool, closes tool->window, deletes new window
*=========================================================================*/

void CloseEmbossedWindow(tool, nw)

struct Tool *tool;
struct NewWindow *nw;

{
	tool->left = tool->window->LeftEdge;
	tool->top = tool->window->TopEdge;
	tool->width = tool->window->Width;
	tool->height = tool->window->Height;
	tool->touched |= TOUCH_EDIT;
	if (tool->window->MenuStrip) ClearMenuStrip(tool->window);
	(*functions->EmbossWindowOff)(tool->window);
	(*functions->FlashyCloseWindow)(tool->window);
	tool->window = NULL;
	if (nw) (*functions->DeleteNewWindow)(nw);
}
