/***
* 	bplib_zoomw.c -- module for bplib.lib
*   1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   6 Jan 94 | created 
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/intuition.h>
#include "bars.h"
#include "barsmacros.h"
#include "proto/bpl_zoomw_protos.h"


extern struct Functions *functions;
extern struct IntuitionBase *IntuitionBase;


/*==========================================================================
* ZoomWindow
*
*  INPUT: pointer to Window
* RETURN: none
*
* EFFECT: makes a window maximum size if it is small, or minimum size
*         if it is already big.  The Window must have valid sizes in it.
*         If necessary, the window is moved to allow it to get bigger.
*
* CAVEAT: Does not check for new TopEdge < 0.
*=========================================================================*/

void ZoomWindow(struct Window *w)

{
	if (w->Height < w->MaxHeight) { /* it is small now */
		if (w->TopEdge + w->MaxHeight > functions->screen->Height) {
			MoveWindow(w,0,functions->screen->Height-(w->TopEdge+w->MaxHeight));
		}
		SizeWindow(w,0,w->MaxHeight - w->Height);
	}
	else { /* it is big now */
		SizeWindow(w,0,w->MinHeight-w->MaxHeight);
	}
}

