/***
* 		ConfigLib_Find.c -- module for ConfigLib.lib
*  	 1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
	3 Feb 93 | created
  31 Dec 93 | modified for new data structures
   1 Jan 94 | fixed after modifications (happy new year)
*/

#include <exec/types.h>
#include "proto/cl_Find_protos.h"
#include "configlib.h"

#include "debug.h"

/*==========================================================================
* FindController
*
*  INPUT: pointer to ControllerInfo[0], number of controller to find,
*         index of ControllerInfo to start with
*
* RETURN: incremented index, or -1 if not found
*
* EFFECT: looks and returns index of first ControllerInfo with controller
*         number at or following passed index
*=========================================================================*/

BYTE FindController(ci, cnum, index)

struct ControllerInfo *ci;
UBYTE cnum;
BYTE index;

{
	BYTE stopit;

	for (stopit=0 ; stopit < index ; stopit++, ci++) { /* find pointer to start */
		if (ci->flags & CIFLAG_LAST) {
			return(-1);     /* hit the end before index */
		}
	}

/*
	/* now, look for controller that is not off */
	for ( stopit=0 ;
	      !stopit && ((ci->controller != cnum) || (ci->type & CITYPE_OFF)) ; ) {
		if (!(stopit = ci->flags & CIFLAG_LAST)) {
			ci++;
			index++;
		}
	}
*/

	stopit=0;
	while (!stopit) {
		if (ci->controller==cnum) { 
			if (!(ci->type & CITYPE_OFF)) {
				return(index);
			}
		}
		if (!(ci->flags & CIFLAG_LAST)) {
			ci++;
			index++;
		}
		else stopit = 1;
	}

	return(-1);
}
