/***
* 		ConfigLib_Init.c -- controller initializations for ConfigLib
*  	 1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   3 Feb 93 | created from configlib.c
  31 Dec 93 | modified for new data structures
  20 Oct 97 | added initvalue to InitControlInfoArray()
*/

#include <exec/types.h>
#include <intuition/intuition.h>
#include "bars.h"
#include "proto/cl_Init_protos.h"
#include "configlib.h"

/*==========================================================================
* InitControlInfo
*
*  INPUT: pointer to ControllerInfo, pertinent info poop
* RETURN: none
*
* EFFECT: copies
*=========================================================================*/

void InitControlInfo(cinfo, controller, range, type, flags)

struct ControllerInfo *cinfo;
BYTE controller;
UBYTE range;
UBYTE type;
UBYTE flags;

{
	cinfo->controller = controller;
	cinfo->range = range;
	cinfo->type = type;
	cinfo->flags = flags|CIFLAG_INIT;
}


/*==========================================================================
* InitControlInfoArray
*
*  INPUT: pointer to ControllerInfo[], number of controllers to initialize, 
*         CITYPE_ bitmask, ControllerInfo.flags bits
*
* RETURN: none
*
* EFFECT: initializes pertinent members using the type flags passed. All  
*         controllers are initially Off.
*=========================================================================*/

void InitControlInfoArray(cinfo, count, type, flags)

struct ControllerInfo *cinfo;
UBYTE count;
UBYTE type;
UBYTE flags;

{
	UBYTE i;
   UBYTE range; /* of controller values based on type */
	BYTE initvalue = (type == CITYPE_SWITCH) ? 0 : -1;

   switch (type & 0x7F) { /* mask in case type passed is already off */
      case CITYPE_SWITCH : range = CI_SWITCHRANGE; break;
      case CITYPE_CONTIN : range = CI_CONTINRANGE; break;
      case CITYPE_CONT14 : range = CI_CONT14RANGE; break;
      case CITYPE_NODIFF : range = CI_NODIFFRANGE; break;
   }
	type |= CITYPE_OFF;
	
	flags &= ~CIFLAG_LAST; /* they can't all be the last element */
	flags |= CIFLAG_INIT;  /* they all be initialized */

   for( i=1 ; i <= count ; i++, cinfo++ ) {
		if (i == count) flags |= CIFLAG_LAST; /* mark the last element */
//      InitController(cinfo,63,range,type,flags);
		cinfo->controller = initvalue;
		cinfo->range = range;
		cinfo->type = type;
		cinfo->flags = flags;
   }
}

