/***
* 		cl_Update.c -- module for ConfigLib.lib
*  	 1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   3 Feb 93 | created
  31 Dec 93 | modified for new data structures
  27 Nov 94 | modified to really mask off CITYPE_OFF bits
*/


#include <exec/types.h>
#include "configlib.h"
#include "proto/cl_Update_protos.h"

/*==========================================================================
* UpdateControllerInfo
*
*  INPUT: pointer to ControllerInfo
* RETURN: none
*
* EFFECT: sets/resets CITYPE_OFF bit in a ControllerInfo based on the
*         type and controller number
*=========================================================================*/

void UpdateControllerInfo(ci)

struct ControllerInfo *ci;

{
	ci->type &= ~CITYPE_OFF;

	if (ci->type & CITYPE_SWITCH) {
		if ( (ci->controller < 63) || (ci->controller > 120) ) { /* in switch range? */
/*			ci->type &= ~CITYPE_OFF;
		}
		else {
*/			ci->type |= CITYPE_OFF; /* set it */
		}
	}
	else if (ci->type & CITYPE_CONTIN) {
		if ( (ci->controller < 0) || (ci->controller > 63) ) { /* in continuous range? */
/*			ci->type &= ~CITYPE_OFF;
		}
		else {
*/			ci->type |= CITYPE_OFF; /* set it */
		}
	}
	else if (ci->type & CITYPE_CONT14) {
		if ( (ci->controller < 0) || (ci->controller > 31) ) { /* in 14-bit continuous range? */
/*			ci->type &= ~CITYPE_OFF;
		}
		else {
*/			ci->type |= CITYPE_OFF; /* set it */
		}
	}
	else if (ci->type & CITYPE_NODIFF) {
		if ( (ci->controller < 0) || (ci->controller > 120) ) { /* who cares? */
/*			ci->type &= ~CITYPE_OFF;
		}
		else {
*/			ci->type |= CITYPE_OFF; /* set it */
		}
	}
	else ci->type |= CITYPE_OFF; /* set it just in case */
}


/*==========================================================================
* UpdateControllers
*
*  INPUT: pointer to array of ControllerInfos
* RETURN: none
*
* EFFECT: calls UpdateControllerInfo for each initialized element in the array
*=========================================================================*/

void UpdateControllers(ci)

struct ControllerInfo *ci;

{
	UBYTE stopit = 0;
	
	while (!stopit) {
		if (ci->flags & CIFLAG_INIT) UpdateControllerInfo(ci);
		stopit = ci->flags & CIFLAG_LAST;
		ci++;
	}
}
