/***
* 		rl_beta.c -- module for Random.lib
*  	 1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE    | WHAT
============================================================================
	 6 Feb 93 | created
*/

#include <exec/types.h>
#include <math.h>
#include "bars.h"
#include "randomlib.h"

extern struct Functions * far functions;

/*==========================================================================
* beta
*
*  INPUT: range, probabilities for p0 and p1
* RETURN: long 0..range
*
* EFFECT: generates scaled Beta distribution
*=========================================================================*/

long beta(long range, struct _Rand_Tool *tool)

{
	double prob0, prob1;
	double t1, t2;
	
	prob0 = 1.0/tool->randparm;
	prob1 = 1.0/tool->randparm2;
	do {
		do {
			t1 = fpow((*functions->random)(65535) / 65535.0,prob0);
		} while (t1==0.0);
		do {
			t2 = fpow((*functions->random)(65535) / 65535.0,prob1);
		} while (t2==0.0);
	} while ( t1+t2 > 1.0 );
	
	return( (long)(range * (t1/(t1+t2)) + 0.5) );
}
