/***
* 		rl_fpow.c -- module for Random.lib
*  	 1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE    | WHAT
============================================================================
	 6 Feb 93 | created
*/

#include <exec/types.h>
#include <math.h>
#include "randomlib.h"

/*==========================================================================
* fpow
*
*  INPUT: value, power
* RETURN: double
*
* EFFECT: exponentiation
*=========================================================================*/

double fpow(double value, double power)

{
	UBYTE neg; /* set if negative */
	double result;

	neg = (power < 0.0) ? 1 : 0;
	power = fabs(power);
	result = exp(log(value)*power);
	if (neg) result = 1.0/result;

	return(result);
}
