/***
* 		rl_poisson.c -- module for Random.lib
*  	 1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE    | WHAT
============================================================================
	 6 Feb 93 | created
*/

#include <exec/types.h>
#include <math.h>
#include "randomlib.h"
#include "bars.h"

extern struct Functions * far functions;

/*==========================================================================
* poisson
*
*  INPUT: range
* RETURN: long 0..range
*
* EFFECT: generates Poisson distribution
*=========================================================================*/

long poisson(long range, struct _Rand_Tool *tool)

{
	long num=0;
	double u,t;

	u = (*functions->random)(65535) / 65535.0;
	t = exp(-tool->randparm);
	while (u > t) {
		num++;
		u *= ((*functions->random)(65535) / 65535.0);
	}
//dprintf("poisson() range=%ld raw num=%ld num=%f\n",range,num,range/65535.0 * num);

	return( (num <= range) ? num : (long)(range/65535.0 * num) );
}
