/***
* 		rl_weibull.c -- module for Random.lib
*  	 1993 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE    | WHAT
============================================================================
	 6 Feb 93 | created
*/

#include <exec/types.h>
#include <math.h>
#include "randomlib.h"
#include "bars.h"

extern struct Functions * far functions;

/*==========================================================================
* weibull
*
*  INPUT: range, spread (tool->randparm), shape (tool->randparm2)
* RETURN: long
*
* EFFECT: generates Weibull distribution scaled to range
*=========================================================================*/

long weibull(long range, struct _Rand_Tool *tool)

{
	double u;

	do {
		u = (*functions->random)(65535) / 65535.0;
	} while (u==0.0 || u==1.0);

	u = 1.0 / (1.0 - u);

	return((long)(range*tool->randparm*fpow(log(u),1.0/tool->randparm2)+0.5));
}
