/***
*		ConfigDiscardImagery.h -- imagery for configuration frame discard gadgets
*		 1994 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   9 Jan 94 | created -- the brushes for the images are in:
	         |   UI:Icons/Brushes/DiscardRenderSmall2.br
	         |   UI:Icons/Brushes/DiscardSelectSmall2.br
  25 Jan 94 | corrected select image to show red background
*/

#ifndef CDIS_IMAGERY
#define CDIS_IMAGERY

#ifndef EXEC_TYPES_H
 #include <exec/types.h>
#endif

#ifndef INTUITION_INTUITION_H
 #include <intuition/intuition.h>
#endif

static USHORT const __chip _DiscardImageData1[] = {
	0xFFFF,0xF800,0xC000,0x1800,0xCC01,0x9800,0xCBFE,0x9800,
	0xCFFD,0x9800,0xCC01,0x9800,0xC000,0x1800,0xC000,0x1800,
	0xFFFF,0xF800,0x0000,0x0800,0x3FFF,0xF800,0x33FE,0x7800,
	0x3401,0xF800,0x37FF,0xF800,0x37FF,0xF800,0x3FFF,0xF800,
	0x3FFF,0xF800,0x7FFF,0xF800
};
static struct Image DiscardRenderImage = {
	0,0,
	21,9,
	3,
	_DiscardImageData1,
	0x0003,0x0000,
	NULL
};

static USHORT const __chip _DiscardImageData2[] = {
	0xFFFF,0xF800,0xC000,0x1800,0xCC0F,0x9800,0xCFFD,0x9800,
	0xCFF7,0x9800,0xCC07,0x9800,0xC000,0x1800,0xC000,0x1800,
	0xFFFF,0xF800,0xFFFF,0xF000,0xFFFF,0xE000,0xF3F0,0x6000,
	0xF403,0xE000,0xF7FF,0xE000,0xF7FF,0xE000,0xFFFF,0xE000,
	0xFFFF,0xE000,0x8000,0x0000,0x0000,0x0000,0x3FFF,0xE000,
	0x33F0,0x6000,0x3000,0x6000,0x3000,0x6000,0x33F0,0x6000,
	0x3FFF,0xE000,0x3FFF,0xE000,0x0000,0x0000
};
/*** this does not have a red background **********************
static struct Image DiscardSelectImage = {
	0,0,
	21,9,
	3,
	_DiscardImageData2,
	0x0003,0x0000,
	NULL
};
**************************************/

/*** this has a red background ***/
static struct Image DiscardSelectImage = {
	0,0,
	21,9,
	3,
	_DiscardImageData2,
	0x0007,0x0000,
	NULL
};

#endif