/***
*		ConfigFrame.h -- stuff for drawing boxes for configuration frames
*		 1994 Another Option   All rights reserved.
***/

/*
============================================================================
|    DATE   | WHAT
============================================================================
   9 Jan 94 | created -- used by cl_Frame to determine where to draw the
	         | boxes and labels for a configuration frame.
*/

#include "barsmacros.h"

/* Location and dimensions for box around config gadgetry.  These */
/* macros are based on the stuff in the tool's Window.  Therefore */
/*	SEVERAL ITEMS IN THE UI DECLARATIONS MUST BE SET APPROPRIATELY FOR
	A CALL TO configlib!DrawConfigFrame() TO RENDER THE FRAME CORRECTLY!

	 set window.MinHeight to lastGadget.Top + lastGadget.Height + 6

	 set the first config gadget.Top to window.MinHeight + 15

	 set window.MaxHeight to:  window.MinHeight + 
                               #config_pots * config_pot.Height +
                               #config_pots * config_pot_spacing + 20
*/


//#if CONFIG_LIB_COMPILE
/* otherwise, these are just for informational purposes */

#define BOX_LEFT 7
#define BOX_TOP (w)->MinHeight+3
#define BOX_WIDTH (w)->Width-8
#define BOX_HEIGHT (w)->MaxHeight-5

/* pens for rendering the box */
#define BOX_APEN BP_LGREY
#define BOX_BPEN -1

/* a label for the config frame */
#define LABEL_STRLEN 22
static char const ConfigLabelText[LABEL_STRLEN] = "Real Time Controllers";

/* and for a box inside the box with a label in it */
/* these assume using the ConfigLabelText[] defined above */
/*! fixed-size font alert !*/
#define LABELBOX_LEFT BOX_LEFT+4
#define LABELBOX_TOP BOX_TOP-4
#define LABELBOX_WIDTH LABELBOX_LEFT + ((LABEL_STRLEN-1) * 8) + 6 //+150
#define LABELBOX_HEIGHT LABELBOX_TOP+10

/* pens for the label text */
#define LABEL_APEN BP_RED
#define LABEL_BPEN BP_BLACK
/* location for the label text in the box*/
#define LABEL_X LABELBOX_LEFT+4
#define LABEL_Y LABELBOX_TOP+8

//#endif

/* but these might be useful in hilo~() routines */
/* pens for rendering config prop gadget labels  */
#define CONFIG_APEN BP_WHITE
#define CONFIG_BPEN BP_BLACK

